#!/usr/bin/env python

import os
import string

import booyo_util
import ifcfg_parser

def network_restart(interface=None):
	print 'network restart'

	if network_stop(interface):
		return network_start(interface)
	return False

def network_start(interface=None):
	command = '/sbin/ifup'
	return network_func('/sbin/ifup', interface)
	   
def network_stop(interface=None):
	command = '/sbin/ifdown'
	return network_func('/sbin/ifdown', interface)

def network_func(command, interface=None):
	if not os.path.exists(command):
		print 'ifup command not found.'
		return False

	if interface:
		command = command + ' ' + interface
		# XXX block... system function
		if os.system(command) == 0:
			return True

		return False
#		f = os.popen(command, 'r')
#		s = f.read()
#		if f:
#			return True, s
#		else:
#			print 'network restart failure'
#			return False, 'error'
	else:
		print 'interface not found...'
		
class NetDevManager:
    def find_wireless(self, path):
	fi = open(path, "r")
	for line in fi.readlines():
		s = line.split('=')
		if s[0].lower() == 'type':
			if s[1].lower().find('wireless') >= 0: 
				fi.close()
				return True
			
	fi.close()
	
	return False

    def dir_listing(self):
	dir_list = os.listdir(self.NET_DEVICE_DIR)
	self.m_device_list = []

	for x in dir_list:
		if x.split('-')[0] == 'ifcfg':
			result = self.find_wireless(self.NET_DEVICE_DIR + x)
			if result == 1:
				self.m_device_list.append(x.split('-')[1])

    def get_device_list(self):
	return self.m_device_list

    def get_default_device(self):
	if not self.m_device_list:
		return 0
	return self.m_device_list[0]

    def __init__(self):
	self.dir_listing()

    # Global Variables	
    NET_DEVICE_DIR = '/etc/sysconfig/network-scripts/'
    m_device_list = []
 

if __name__ == "__main__":
    NetDevManager()
