#!/usr/bin/env python

import os

import ifcfg_parser

class ProfileManager:
    # 지역변수에 저장된 정보를 파일로 작성한다.
    def write(self, profile):
    	dir_list = os.listdir('.')
    	self.makeStorageDir(dir_list)
		
    	# 만들고자 하는 파일이 현재 존재하는지 확인한다.
	list = os.listdir(self.STORAGE_DIR)
	if 1 == self.isExistProfile(profile):
		print 'Exist file : ' + profile
		return 0
	
	# 파일을 작성한다.	
	path = self.STORAGE_DIR + "/" + "ifcfg-" + profile.split('\n')[0]
	fo = open(path, "w")
	for x in self.m_profile_data_dic.keys():
		if x == self.m_title_list[0]:
			continue
		elif x == self.m_title_list[1]:
			fo.write("DEVICE=" + self.m_profile_data_dic[x] + "\n")
		elif x == self.m_title_list[2]:
			fo.write("ESSID=" + self.m_profile_data_dic[x] + "\n")
		elif x == self.m_title_list[3]:
			fo.write("BOOTPROTO=" + self.m_profile_data_dic[x] + "\n")
		elif x == self.m_title_list[4]:
			fo.write("IPADDR=" + self.m_profile_data_dic[x] + "\n")
		elif x == self.m_title_list[5]:
			fo.write("GATEWAY=" + self.m_profile_data_dic[x] + "\n")
		elif x == self.m_title_list[6]:
			fo.write("NETMASK=" + self.m_profile_data_dic[x] + "\n")
	fo.write("TYPE=Wireless" + "\n")
	fo.close()

    # 프로파일 데이터를 저장할 디렉토리가 존재하는 지 확인하여
    # 존재하지 않으면 디렉토리를 만든다.
    def makeStorageDir(self, dir_list):
	for x in dir_list:
		if x == self.STORAGE_DIR:
			return 1
	
	#os.mkdir(self.STORAGE_DIR, 0644)
	os.system('mkdir -p ' + self.STORAGE_DIR)

    # 프로파일 데이터를 저장하고 있는 디렉토리 안에
    # 만들고자 하는 파일이 존재하는지 확인한다.
    def isExistProfile(self, profile):
    	file_list = os.listdir(self.STORAGE_DIR)
	for x in file_list:
		if x == profile:
			return 1

    # 프로필 파일을 /etc/.../ifcfg-eth#N 파일의 위치로 이동기켜 적용시킨다.
    def apply_ifcfg(self, profile, device=None):
	path = self.STORAGE_DIR + "/ifcfg-" + profile
	if 0 == self.isExistProfile(path):
		print 'Not exist file : ' + filename
		return 0
		
	if device == None and (not self.m_profile_data_dic[self.m_title_list[1]]):
		netDev = net_device_manager.NetDevManager()
		device = netDev.get_default_device()
		self.m_profile_name_list['DEVICE'] = device

	dist = self.IFCFG_SYSDIR + 'ifcfg-' + self.m_profile_name_list[profile]['DEVICE']
	self.copy(path, dist)

    def copy(self, src_file, tar_file):
    	fi = open(src_file, "r")
	fo = open(tar_file.split('\n')[0], "w")

	for s in fi.readlines():
		fo.write(s)
		
	fo.close()
	fi.close()

    def set_profile_data(self, data_dic):
	self.m_profile_data_dic = {}
	self.m_profile_data_dic = data_dic

    def get_essid_names(self):
    	list = []
    	for x in self.m_profile_name_list.keys():
		list.append(self.m_profile_name_list[x]['ESSID'].split('\n')[0])

	return list

    def get_profile_name(self):
	return self.m_profile_name_list.keys()

    def read_profile(self):
	file_list = os.listdir(self.STORAGE_DIR)
	for x in file_list:
		if x.split('-')[0] == 'ifcfg':
			profile_name = x.split('-')[1]
			data = {}
			self.m_profile_name_list[profile_name] = data
			fi = open(self.STORAGE_DIR + "/" + x, "r")
			for s in fi.readlines():
				data[s.split('=')[0]] = s.split('=')[1]
				
    def __init__(self):
	dir_list = os.listdir('.')
	self.makeStorageDir(dir_list)

	self.m_profile_name_list = {}
	self.read_profile()

    m_profile_name_list = {}
    m_title_list = ['profile', 'interface', 'essid', 'radio', 'ip', 'network', 'netmask']	
    m_profile_data_dic = {}
    #STORAGE_DIR = 'ifcfg_data'
    STORAGE_DIR = '/etc/sysconfig/networking/APSearcher/profile/'
    IFCFG_SYSDIR = '/etc/sysconfig/network-scripts/'

if __name__ == "__main__":
    ProfileManager()
