#!/usr/bin/env python
# vim:ts=8:sw=4

import pygtk
pygtk.require('2.0')
import os
import gtk
import sys
sys.path.append('../backend')
sys.path.append('../network')

import basedlg
import net_device_manager
import ap_scan
import profile_manager
import ifcfg_parser
import dlg_error


class DlgAP(basedlg.BaseDialogClass):
	def __init__(self, parent_widget, name=None):
		basedlg.BaseDialogClass.__init__(self, parent_widget)
		if name:
			basedlg.BaseDialogClass.set_title(name)

		self.profile_layout.hide()
		self.init_interface()

	def init_interface(self, interface_list=None):
		if interface_list:
			self.combo_interface.set_popdown_strings(interface_list)
		else:
			netManager = net_device_manager.NetDevManager()
                	slist = netManager.get_device_list()
                	if len(slist) == 0:
                        	slist = ['Nothing']
                	self.combo_interface.set_popdown_strings(slist)

	def set_essid(self, essid):
		self.combo_essid.entry.set_text(essid)
			
	def init_essid(self, essid_list=None):
		if essid_list:
			self.combo_essid.set_popdown_strings(essid_list)
		else:
			self.combo_essid.set_popdown_strings(ap_scan.get_ap_list())

	def callback_ok_button(self, widget, entry, window):
		print 'ok_button clicked'
		devicename = self.combo_interface.entry.get_text()
		if devicename:
			print devicename
			ifcfg_agent = ifcfg_parser.IfcfgParser(devicename)
			ifcfg_agent.set_essid(self.combo_essid.entry.get_text())
			ifcfg_agent.write()

			# XXX check ret
			ret = net_device_manager.network_restart(devicename)
			if not ret:
				error = dlg_error.DlgError('연결이 되지 않았습니다.\n다시 시도해주세요!!', '연결실패')	
			else:
				error = dlg_error.DlgError('정상적으로 연결이 되었습니다.', '연결성공')	
		else:
			print 'arguments exception'
		window.destroy()
