#!/usr/bin/env python
# vim:ts=8:sw=4

import pygtk
pygtk.require('2.0')
import os
import sys
import gtk

import basedlg

import ap_scan
import profile_manager
import net_device_manager
import dlg_error

class DlgProfile(basedlg.BaseDialogClass):
	def __init__(self, parent_widget=None, name=None):
		basedlg.BaseDialogClass.__init__(self, parent_widget)
		if name:
			basedlg.BaseDialogClass.set_title(name)
	
		self.init_interface()
		self.init_essid()

        def init_interface(self, interface_list=None):
                if interface_list:
                        self.combo_interface.set_popdown_strings(interface_list)
                else:
                        netManager = net_device_manager.NetDevManager()
                        slist = netManager.get_device_list()
                        if len(slist) == 0:
                                slist = ['Nothing']
                        self.combo_interface.set_popdown_strings(slist)

	def enter_callback(self, widget, entry):
		entry_text = entry.get_text()
		print "Entry contents: %s\n" % entry_text
	   
	def init_profile_name(self, name=None):
		if name:
			self.entry_profile.set_text(name)

	def init_essid(self, essid_list=None):
                if essid_list:
                        self.combo_essid.set_popdown_strings(essid_list)
                else:
			slist = ap_scan.get_ap_list()
			if len(slist) == 0:
				slist = ['Nothing']
                        self.combo_essid.set_popdown_strings(slist)

	def callback_ok_button(self, widget, entry, window):
		profile = self.entry_profile.get_text()
		interface = self.combo_interface.entry.get_text()
		if interface == 'Nothing':
			print self.ERROR_STR_DLG_PROFILE_1
		essid = self.combo_essid.entry.get_text()

		if self.radio_flag:
			ipaddr = self.get_ipaddress()
			if ipaddr == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError(_('Again insert value'))
				return 0
			
			network = self.get_network()
			if network == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError(_('Again insert value'))
				return 0
			netmask = self.get_netmask()
			if netmask == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError(_('Again insert value'))
				return 0
	
		dic_data = {}
		dic_data['profile'] = profile
		dic_data['interface'] = interface
		dic_data['essid'] = essid

		if self.get_radio() == 0:
			dic_data['radio'] = 'dhcp'
		else:
			dic_data['radio'] = 'static'
			dic_data['ip'] = ipaddr
			dic_data['network'] = network
			dic_data['netmask'] = netmask

		profile = profile_manager.ProfileManager()
		profile.set_profile_data(dic_data)
		profile.write(dic_data['profile'])

		self.parent.clear_model()
		self.parent.add_model()

		window.destroy()

	def get_radio(self):
		if self.radio_button1.get_active():
			return 0
		return 1

	def destroy(self, widget, data=None):
		pass

    	ERROR_STR_DLG_PROFILE_1 = 'setting interface'

def main():
	gtk.main()
	return 0

if __name__ == "__main__":
	DlgProfile()
	main()
